import * as echarts from "echarts";
import {getAsol2} from "../../api/realTimeData";
import { chartsWidth,dataLength, emptyData,handelBtcPrice, handelProfitrate, handelZoom, handelLineType, handelWatermark, handelSwitchs, handelSmaData, getDateArray, fetchBtcPrice, fetchEthPrice } from "../../util/processingData"

export default {
    data() {
        return {
            lengthTimer:null,
            asolLoading: false,
            option: {
                tooltip: {
                    trigger: "axis",
                    //解决tooltip显示不全问题1 
                    confine: true,
                    formatter: function (params) {

                        
                        if (params[0].axisType == `xAxis.time`) {
                            const date = new Date(params[0].value[0]);
                            const year = date.getFullYear();
                            const month = date.getMonth() + 1;
                            const day = date.getDate();
                            let time =  `${year}-${month}-${day}`;
                            var res =time    
                        }else{
                            var res = params[0].axisValue
                        }
                                         

                        for (let i = 0; i < params.length; i++) {
                            res += `</br>${params[i].marker} ${params[i].seriesName} &nbsp&nbsp&nbsp&nbsp <span style="font-weight: bold">${params[i].value[1]}</span>`

                        }
                        return res;
                    }

                },
                legend: {
                    right: "100",
                    //处理legengd过长
                    // formatter: function (name) {

                    //     return echarts.format.truncateText(name, 60, '14px Microsoft Yahei', '…');
                    // },
                    // data:[`sopr`,'asopr','easopr','lthsopr','sthsopr',],
                    // selected:{
                    //     'asopr': false,
                    //     'easopr': false,
                    //     'lthsopr': false,
                    //     'sthsopr': false,                      
                    // }
                },
                xAxis: {
                    type: "time",
                    boundaryGap: false,
                    //   axisLabel: {
                    //     formatter: `{yyyy}-{MM}-{dd}`,
                    //   },
                    data: []
                },
                yAxis: [
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        // axisLabel: {
                        //   formatter: function (e) {

                        //     let value;
                        //     if (e > 1000000) {
                        //       value = e / 100000;
                        //     } else if (e > 100000) {
                        //       value = e / 1000;
                        //     } else {
                        //       value = e / 100;
                        //     }
                        //     return value;
                        //   },
                        // },
                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: true,
                        position: "right"
                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: false,
                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: false,
                    },
                ],
                dataZoom: [
                    {
                        type: "inside",
                        start: 0,
                        end: 100,
                    },
                    {
                        start: 0,
                        end: 100,
                    },
                ],
                series: [
                    {
                        name: "ASOL",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        showSymbol: false,
                        symbolSize: 5,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#f7931a",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#f7931a",
                            width: "1",
                        },
                        data: [],
                        yAxisIndex: 0,
                    },
                    {
                        name: "ASOL(CE)",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        showSymbol: false,
                        symbolSize: 5,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#3aa46e",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#3aa46e",
                            width: "1",
                        },
                        data: [],
                        yAxisIndex: 0,
                    },
                    {
                        name: "Price[BTC]",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        symbolSize: 5,
                        showSymbol: false,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#888888",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#888888",
                            width: "1",
                        },
                        yAxisIndex: 1,
                        data: [],
                        //绘制右侧Y轴
                        // markLine: {
                        //     symbol: ["none", "none"], //去掉箭头
                        //     itemStyle: {
                        //         normal: {
                        //             lineStyle: { type: "solid", color: "rgba(0,0,0,0.01)" },
                        //         },
                        //     },
                        //     // lineStyle:{
                        //     //   color:"red"
                        //     // },

                        //     label: {
                        //         formatter: "{b}",
                        //         fontSize: 10,
                        //         color: "rgba(0,0,0,0.8)",
                        //         align: "left",
                        //     },
                        //     data: [
                        //         // {
                        //         //     name: "0",
                        //         //     yAxis: 0,
                        //         // },
                        //         //  {
                        //         //   name: "$40W",
                        //         //   yAxis: 400000,
                        //         // },
                        //         {
                        //             name: "$70W",
                        //             yAxis: 700000,
                        //         },
                        //         {
                        //             name: "$40W",
                        //             yAxis: 400000,
                        //         },

                        //         {
                        //             name: "$10W",
                        //             yAxis: 100000,
                        //         },
                        //         {
                        //             name: "$100W",
                        //             yAxis: 1000000,
                        //             // position: ['100%', '50'],
                        //         },
                        //         {
                        //             name: "$120W",
                        //             yAxis: 1200000,
                        //         },

                        //         {
                        //             name: "$140W",
                        //             yAxis: 1400000,
                        //         },
                        //     ],
                        // },
                    },
                    // {
                    //     name: "Price [ETH]",
                    //     type: "line",
                    //     smooth: false, //线条是否圆滑
                    //     symbol: "circle",
                    //     symbolSize: 5,
                    //     showSymbol: false,
                    //     itemStyle: {
                    //         color: "#627eea",
                    //         borderColor: "rgba(221,220,107,0.1)",
                    //         borderWidth: 12,
                    //     },
                    //     lineStyle: {
                    //         //线条样式
                    //         color: "#627eea",
                    //         width: "1",
                    //     },
                    //     yAxisIndex: 3,
                    //     data: [],
                    // },

                ],
            },
            params: {
                req: "asol",
                radius: "btc"
            },
            asolData: [],
            priceTime: "",
            btcPrice: [],
            parmesTime: {
                start: "",
                end: ""
            },
            switch3: "",
            btcFlag: null,
            ethFlag: null,
            fatherSmaData: [],
            start: "",
            end: "",
            sma: "",
            zoomStart: 0,
            zoomEnd: 0,
            dataSelection: [
                {
                  value: "1d",
                  label: "home.day1",
                  disabled:false,
                  authority:"guest",
                  grade:1,
                },
                {
                  value: "realTime",
                  label: "home.realTimeData",
                  disabled:false,
                  authority:"vip",
                  grade:4,
                },
              ],
              realTimeData:"",
        }
    },
    mounted() {

        this.fetchAsol(this.params.req, this.params.radius)
        this.switch3 = handelSwitchs(this.option, this.switch3)
        this.$addStorageEvent(1, "zoomStart", this.zoomStart);
        this.$addStorageEvent(1, "zoomEnd", this.zoomEnd);
        this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
        this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
        window.addEventListener("setItem", () => {
            this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
            this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
            this.zoomStart = localStorage.getItem("zoomStart")
            this.zoomEnd = localStorage.getItem("zoomEnd")
        })

    },
    methods: {
        handleSelect(activeValue){
            if (activeValue=="1d") {
                this.realTimeData = false
                this.fetchAsol(this.params.req, this.params.radius)
            }else{
                this.realTimeData = true
                this.fetchAsol2()
            }
        },
        //初始化图表
        inCharts() {
            // this.myChart = echarts.init(document.getElementById("asolBox"));
            if (this.myChart == null) {
                this.myChart = echarts.init(document.getElementById("asolBox"));
            }
            this.option = handelZoom(this.myChart, this.option, this, this.zoomStart, this.zoomEnd)

            this.myChart.setOption(this.option);
            chartsWidth("asolBox", this);
            window.addEventListener("resize", () => {
                if (this.myChart) this.myChart.resize();
            });
        },
        async fetchAsol2(){
            this.asolLoading = true 
            const { data } = await getAsol2()
            let Asol2Data = data.data

             //空数据处理
             let noData = emptyData(data.data, this.option.series, this.inCharts, this)
             if (noData) {
                 this.asolLoading = false
                 return
             }
             this.option.xAxis.type="category"
             this.option = handelWatermark(this.option)
             let asol =[]
             let eaasol =[]
             let xAxisData=[]
             let price=[]
             Asol2Data.forEach(item=>{
                item.date=`${item.date.split("T")[0]} ${
                    item.date.split("T")[1].split(`.`)[0]
                  } `;
                  asol.push(item.asol.toFixed(2))
                  eaasol.push(item.eaasol.toFixed(2))
                xAxisData.push(item.date)
                price.push(item.price.toFixed(2))
             })


             this.option.xAxis.data = xAxisData
             this.option.series[0].data = asol
             this.option.series[1].data = eaasol
             this.option.series[2].data = price
             this.inCharts()
             console.log(this.option,"揭谛揭谛");
             this.asolLoading = false
        },

        async fetchAsol(req, radius, start, end, sma) {
            this.asolLoading = true
            const { data } = await this.$API.getAsol(req, radius, start, end, sma)
            this.asolData = data.data
            //空数据处理
            let noData = emptyData(data.data, this.option.series, this.inCharts, this)
            if (noData) {
                this.asolLoading = false
                return
            }
            this.start = this.asolData[0].date.split("T")[0]
            this.end = this.asolData[this.asolData.length - 1].date.split("T")[0]

            this.option.xAxis.type="time"
            //添加水印
            this.option = handelWatermark(this.option)
            //根据渲染的数据时间渲染对应的价格线和移动平均线
            this.$nextTick(() => {
                //移动平均线没值 才渲染正常价格数据 
                if (this.start && !this.fatherSmaData[0]) {
                    this.handelSonBtcPrice("BTC", true)
                }
                //点击时间 移动平均线有值 就渲染查询移动平均线
                if (this.fatherSmaData[0] && this.start) {
                    this.handelSonSma(this.fatherSmaData, this.start, this.end)
                }
                //渲染ETH
                if (this.ethFlag) {
                    this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));
                    this.handelSonEthPrice("ETH", this.ethFlag)
                }
            })
            // //请求BTC价格
            // const price = await this.$API.getBtcPrice(start, end);
            // this.btcPrice = price.data.data


            let asolValueList = []
            let eaasolValueList = []

            this.asolData.forEach(item => {
                asolValueList.push(Number(item.asol.toFixed(2)))
                eaasolValueList.push(Number(item.eaasol.toFixed(2)))


                //判断渲染与上面数据时间一致得价格数据
                //  this.btcPrice.forEach(price => {

                //     this.priceTime = price.time.split("T")[0]
                //     // console.log(this.timer === this.priceTime);
                //     if (time === this.priceTime) {

                //         priceValueList.push(Number(parseInt(price.value*100)/100))
                //         newPriceData.push(price)
                //     }
                // })
            })

            this.option.series[0].data = handelProfitrate(this.asolData, asolValueList)
            this.option.series[1].data = handelProfitrate(this.asolData, eaasolValueList)
            // this.option.series[2].data = handelBtcPrice(newPriceData, priceValueList)

            this.inCharts()
            this.asolLoading = false

            //判定页面条数是否一致
            if (this.lengthTimer) {
                clearTimeout(this.lengthTimer)
            }
            this.lengthTimer = setTimeout(() => {

                this.$addStorageEvent(1, "lengthFlag", dataLength(this.option, this.option.series[0].data.length), );

            }, 10000)
        },
        //接收Home传的时间handelParmesTime
        handelSonTime(start, end) {
            this.parmesTime.start = start;
            this.parmesTime.end = end;
            this.fetchAsol(this.params.req, this.params.radius, this.parmesTime.start, this.parmesTime.end, this.sma)
        },
        //点击对数/线性按钮切换
        handelLineSwitch() {
            this.option = handelLineType(this.option)
            this.switch3 = handelSwitchs(this.option, this.switch3)
            this.myChart.setOption(this.option);

        },
        // 请求BTC价格
        async fetchBtcPrice(radius, start, end) {
            //请求BTC价格
            const price = await this.$API.getBtcPrice2(radius, start, end);
            this.btcPrice = price.data.data
            if (!this.btcPrice) {//价格未查询到数据的情况              
                this.option.series[2].data.length = 0

            } else {

                let priceValueList = []
                let newPriceData = []
                this.btcPrice.forEach(price => {
                    priceValueList.push(Number(parseInt(price.value * 100) / 100))
                    newPriceData.push(price)
                })
                this.option.series[2].data = handelBtcPrice(newPriceData, priceValueList)

            }
            this.inCharts()
        },
        // 请求Eth价格
        async fetchEthPrice(radius, start, end) {
            const price = await this.$API.getBtcPrice2(radius, start, end);
            this.ethPrice = price.data.data
            if (!this.ethPrice) {
                this.option.series[3].data.length = 0
            } else {
                let priceValueList = []
                let newPriceData = []
                this.ethPrice.forEach(price => {
                    priceValueList.push(Number(parseInt(price.value * 100) / 100))
                    newPriceData.push(price)
                })
                this.option.series[3].data = handelBtcPrice(newPriceData, priceValueList)
            }

            this.inCharts()
        },
        //父级点击BTC价格按钮
        handelSonBtcPrice(radius, flag) {
            this.btcFlag = flag

            fetchBtcPrice("BTC", this.option.series[2], this.start, this.end, this.inCharts, this, this.btcFlag)


        },
        //父级点击ETH价格按钮
        handelSonEthPrice(radius, flag) {

            this.ethFlag = flag
            this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));
            fetchEthPrice("ETH", this.option.series[3], this.start, this.end, this.inCharts, this, this.ethFlag)


        },
        //父级选择Sma
        handelSonSma(smaDataList) {
            this.sma = smaDataList

            this.fetchAsol(this.params.req, this.params.radius, this.parmesTime.start, this.parmesTime.end, this.sma)

            this.$addStorageEvent(1, "sma", this.sma);

            this.realTimeData = false


            // this.fatherSmaData = smaDataList
            // handelSmaData(smaDataList, this.option.series[2], this.inCharts,this.start, this.end)

        },

    },
    beforeDestroy() {
        if (this.lengthTimer) {
            clearTimeout(this.lengthTimer)
        }
    }
}